//===- LuaBindings.cpp ---------------------------------------------===//
//
//                     The LLVM Compiler Infrastructure
//
// This file is distributed under the University of Illinois Open Source
// License. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//
//
// LuaBindings.cpp - Main file for the LuaBindings plugin.
//
//===----------------------------------------------------------------------===//

#include "LuaBindings.h"

namespace LuaBindings {

using namespace clang;

static FrontendPluginRegistry::Add<LuaBindings::LuaBindingsAction>
X("luabindings", "generate lua bindings");

#ifdef LLVM_ON_WIN32
  #define LINKAGE __declspec(dllexport)
#else
  #define LINKAGE
#endif

#ifdef LLVM_ON_WIN32
extern "C" {
  // Note:  The following function name needs to be constructed using the
  // plug-in name, i.e. "Get_(plug-in name)_Node".
  LINKAGE void *Get_luabindings_Node()
  {
    return (void*)&X.Node;
  }
} // extern "C"
#endif

} // namespace LuaBindings
