//===- LuaBindings.h ---------------------------------------------===//
//
//                     The LLVM Compiler Infrastructure
//
// This file is distributed under the University of Illinois Open Source
// License. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//
//
// LuaBinding plugin - Generates Lua bindings from annotated sources.
//
//===----------------------------------------------------------------------===//

#include "clang/Frontend/FrontendPluginRegistry.h"
#include "clang/AST/ASTConsumer.h"
#include "clang/AST/AST.h"
#include "clang/Frontend/CompilerInstance.h"
#include "llvm/Config/config.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/Path.h"
#include "llvm/Support/ToolOutputFile.h"

namespace LuaBindings {

  // Wrappers for Lua types.
typedef ptrdiff_t LuaInteger;
typedef double LuaNumber;
typedef char *LuaString;

} // namespace LuaBindings

#include "LuaBindingsConsumer.h"
#include "LuaBindingsAction.h"
