//===- LuaBindingsAction.h ---------------------------------------------===//
//
//                     The LLVM Compiler Infrastructure
//
// This file is distributed under the University of Illinois Open Source
// License. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//
//
// LuaBindingsAction.h - Declaration of LuaBindingsAction.
//
//===----------------------------------------------------------------------===//

namespace LuaBindings {

class LuaBindingsAction : public clang::PluginASTAction {
protected:
    // Output file path given to the plugin.
  std::string OutputFileName;
    // Include file to be #include'ed in the output file.
  std::string IncludeFileName;
    // Error message.
  std::string ErrorInfo;
    // The output stream manager.
  llvm::tool_output_file *OutputFile;

  // Clang calls this to create an AST consumer object.
  clang::ASTConsumer *CreateASTConsumer(clang::CompilerInstance &CI, llvm::StringRef);
  // Parse the -plugin-arg-luabindings arguments.
  bool ParseArgs(const clang::CompilerInstance &CI,
                 const std::vector<std::string>& args);
  // Print a help message.
  void PrintHelp(llvm::raw_ostream& ros);
public:
  LuaBindingsAction();
  virtual ~LuaBindingsAction();
};

} // namespace LuaBindings
