// Function.h - Example file for Clang LuaBinding plugin.  This file contains declarations to be bound.

#include "LuaBindings.h"

class Class1
{
protected:
  int member;
  const char *str;
public:
  Class1();
  Class1(int arg);
  Class1(int arg, const char *arg2);
  ~Class1();
  int GetMember();
  void SetMember(int value);
  const char *GetString();
  void SetString(const char *value);
  int PublicDataMember;
} LUABIND_CLASS;

class Class2 : public Class1
{
  float flt;
public:
  Class2();
  Class2(float arg);
  Class2(int arg);
  Class2(int arg, const char *arg2);
  Class2(int arg, float farg, const char *arg2);
  ~Class2();
  float GetFloat();
  void SetFloat(float value);
  int OverloadedFunction(int intArg, const char *strArg);
  float OverloadedFunction(const char *strArg, int intArg);
private:
  void PrivateFunction() {};
protected:
  void ProtectedFunction() {};
public:
  void PublicFunction() {};
  //void Orphan() {};
  Class2 *ReturnThis() { return(this); }
} LUABIND_CLASS;

class Class3 : public Class1
{
public:
  int IntMember;
  float FloatMember;
  double DoubleMember;
  const char *StringMember;
  MyFunctions::StructType StructMember;
  MyFunctions::StructType *StructPointerMember;
  MyFunctions::ClassType ClassMember;
  MyFunctions::ClassType *ClassPointerMember;
  Class3();
} LUABIND_CLASS;

extern int GlobalIntVariable LUABIND_VARIABLE;

namespace VariableNamespace {
  extern int NamespaceIntVariable LUABIND_VARIABLE;
}

int BoundFunction(const char *argString) LUABIND_FUNCTION;
