// Function.h - Example file for Clang LuaBinding plugin.  This file contains declarations to be bound.

#include "LuaBindings.h"

void VoidFunction() LUABIND_FUNCTION;

namespace MyFunctions LUABIND_NAMESPACE {

enum EnumType
{
  enumMember234 = 234,
  enumMemberNext
};

int IntFunction();
long LongFunction();
short ShortFunction();
unsigned UnsignedFunction();
float FloatFunction();
double DoubleFunction();
void *VoidPointerFunction();
int *IntPointerFunction();
char CharFunction();
char *CharPointerFunction();
const char *ConstCharPointerFunction();
StructType StructFunction();
StructType *StructPointerFunction();
ClassType ClassFunction();
ClassType *ClassPointerFunction();
EnumType EnumFunction();

void FunctionIntArg(int intArg1);
void FunctionFloatArg(float floatArg1);
void FunctionDoubleArg(double doubleArg1);
void FunctionIntPointerArg(int *intPointerArg1);
void FunctionCharArg(char charArg1);
void FunctionCharPointerArg(char *charPointerArg1);
void FunctionConstCharPointerArg(const char *constCharPointerArg1);
void FunctionStructArg(StructType structArg1);
void FunctionStructPointerArg(StructType *structPointerArg1);
void FunctionClassArg(ClassType classArg1);
void FunctionClassPointerArg(ClassType *classPointerArg1);
void FunctionEnumArg(EnumType enumArg1);

} // namespace MyFunctions

namespace OtherFunctions {

void FunctionIntArgs(int intArg1, int intArg2) LUABIND_FUNCTION;
void FunctionOther(int arg);

} // namespace OtherFunctions

