// LuaBindings.h - Definitions for using the Clang-based LuaBindings plugin.

#ifdef __clang__
  #define LUABIND_FUNCTION __attribute__((annotate("LuaBind")))
  #define LUABIND_VARIABLE __attribute__((annotate("LuaBind")))
  #define LUABIND_CLASS __attribute__((annotate("LuaBind")))
  #define LUABIND_NAMESPACE __attribute__((annotate("LuaBind")))
#else
  #define LUABIND_FUNCTION
  #define LUABIND_VARIABLE
  #define LUABIND_CLASS
  #define LUABIND_NAMESPACE
#endif

#ifndef LUABINDING_H
#define LUABINDING_H

namespace MyFunctions LUABIND_NAMESPACE {

struct StructType
{
  int member;
};

class ClassType
{
public:
 int member;
 ClassType(int arg) : member(arg) {}
 int GetMember() { return member; }
};

}

#endif
