// Bindings.cpp: Generated by the LuaBindings plugin.
// Usage: Clang -cc1 -load (path)/LuaBindings.[so|dll] -plugin luabindings \ 
//          -plugin-arg-luabindings -out=(bindingsFile).cpp \ 
//          [-plugin-arg-luabindings -include=(includeFile).cpp] \ 
//          [-x c++] (inputFile).[h|cpp]

extern "C" {
#include <string.h>
#include "lua.h"
#include "lauxlib.h"
#include "lualib.h"
}

#include "../BindIn/Bindings.h"

namespace Bindings {

int RegisterClass(lua_State *L, const char *className, const luaL_reg *methodTable,
    int (*disposeFunction)(lua_State *L), int (*createFunction)(lua_State *L)) {
  lua_newtable(L);
  int methodTableIndex = lua_gettop(L);
  luaL_newmetatable(L, className);
  int metaTable   = lua_gettop(L);
  lua_pushliteral(L, "__metatable");
  lua_pushvalue(L, methodTableIndex);
  lua_settable(L, metaTable);
  lua_pushliteral(L, "__index");
  lua_pushvalue(L, methodTableIndex);
  lua_settable(L, metaTable);
  lua_pushliteral(L, "__gc");
  lua_pushcfunction(L, disposeFunction);
  lua_settable(L, metaTable);
  lua_pop(L, 1);
  luaL_register(L, 0, methodTable);
  lua_pop(L, 1);
  lua_register(L, className, createFunction);
  return 1;
}

void FunctionMatchError(lua_State *L, const char *functionName) {
  char buffer[300];
  strcpy(buffer, "No matching function call signature for ");
  strncat(buffer, functionName, 256);
  strcat(buffer, ".");
  lua_pushstring(L, buffer);
  lua_error(L);
}

class Bindings_StructType {
  static const luaL_reg MethodTable[];
  static int member(lua_State *L) {
    MyFunctions::StructType *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      int returnValue = self->member;
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->member = (int)luaL_checkinteger(L, 2);
    else
      FunctionMatchError(L, "member");
    return 1;
  }
  static int Create(lua_State *L) {
    MyFunctions::StructType *self = new MyFunctions::StructType;
    *(void **)lua_newuserdata(L, sizeof(void *)) = self;
    luaL_getmetatable(L, "StructType");
    lua_setmetatable(L, -2);
    return 1;
  }
  static MyFunctions::StructType *Check(lua_State *L, int narg) {
    luaL_checktype(L, narg, LUA_TUSERDATA);
    void *self = luaL_checkudata(L, narg, "StructType");
    if (!self)
      luaL_typerror(L, narg, "StructType");
    return *(MyFunctions::StructType**)self;
  }
  static int Dispose(lua_State *L) {
    MyFunctions::StructType *self = (MyFunctions::StructType*)(*(void **)(lua_touserdata(L, 1)));
    delete self;
    return 0;
  }
public:
  static int Register(lua_State *L) {
    return RegisterClass(L, "StructType", MethodTable, Dispose, Create);
  }
  static int Adopt(lua_State *L, MyFunctions::StructType *obj) {
    *(void **)lua_newuserdata(L, sizeof(void *)) = obj;
    luaL_getmetatable(L, "StructType");
    lua_setmetatable(L, -2);
    return 1;
  }
  static int Orphan(lua_State *L) {
    MyFunctions::StructType **objp = (MyFunctions::StructType **)luaL_checkudata(L, 1, "StructType");
    *objp = NULL;
    return 1;
  }
};
const luaL_reg Bindings_StructType::MethodTable[] = {
  {"member", Bindings_StructType::member},
  {"Orphan", Bindings_StructType::Orphan},
  {NULL, NULL}
};

class Bindings_ClassType {
  static const luaL_reg MethodTable[];
  static int member(lua_State *L) {
    MyFunctions::ClassType *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      int returnValue = self->member;
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->member = (int)luaL_checkinteger(L, 2);
    else
      FunctionMatchError(L, "member");
    return 1;
  }
  static int GetMember(lua_State *L) {
    MyFunctions::ClassType *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      int returnValue = self->GetMember();
      lua_pushinteger(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetMember");
    return 1;
  }
  static int Create(lua_State *L) {
    MyFunctions::ClassType *self = NULL;
    int stackCount = lua_gettop(L);
    if ((stackCount == 1)
        && lua_isnumber(L, 1)) {
      int arg = (int)luaL_checkinteger(L, 1);
      self = new MyFunctions::ClassType(arg);
    }
    else
      FunctionMatchError(L, "ClassType");
    *(void **)lua_newuserdata(L, sizeof(void *)) = self;
    luaL_getmetatable(L, "ClassType");
    lua_setmetatable(L, -2);
    return 1;
  }
  static MyFunctions::ClassType *Check(lua_State *L, int narg) {
    luaL_checktype(L, narg, LUA_TUSERDATA);
    void *self = luaL_checkudata(L, narg, "ClassType");
    if (!self)
      luaL_typerror(L, narg, "ClassType");
    return *(MyFunctions::ClassType**)self;
  }
  static int Dispose(lua_State *L) {
    MyFunctions::ClassType *self = (MyFunctions::ClassType*)(*(void **)(lua_touserdata(L, 1)));
    delete self;
    return 0;
  }
public:
  static int Register(lua_State *L) {
    return RegisterClass(L, "ClassType", MethodTable, Dispose, Create);
  }
  static int Adopt(lua_State *L, MyFunctions::ClassType *obj) {
    *(void **)lua_newuserdata(L, sizeof(void *)) = obj;
    luaL_getmetatable(L, "ClassType");
    lua_setmetatable(L, -2);
    return 1;
  }
  static int Orphan(lua_State *L) {
    MyFunctions::ClassType **objp = (MyFunctions::ClassType **)luaL_checkudata(L, 1, "ClassType");
    *objp = NULL;
    return 1;
  }
};
const luaL_reg Bindings_ClassType::MethodTable[] = {
  {"GetMember", Bindings_ClassType::GetMember},
  {"member", Bindings_ClassType::member},
  {"Orphan", Bindings_ClassType::Orphan},
  {NULL, NULL}
};

void Bindings_EnumType(lua_State *L) {
  lua_newtable(L);
  lua_pushliteral(L, "enumMember234");
  lua_pushnumber(L, (unsigned int)MyFunctions::enumMember234);
  lua_settable(L, -3);
  lua_pushliteral(L, "enumMemberNext");
  lua_pushnumber(L, (unsigned int)MyFunctions::enumMemberNext);
  lua_settable(L, -3);
  lua_setglobal(L, "EnumType");
}

class Bindings_Class1 {
  static const luaL_reg MethodTable[];
  static int PublicDataMember(lua_State *L) {
    Class1 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      int returnValue = self->PublicDataMember;
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->PublicDataMember = (int)luaL_checkinteger(L, 2);
    else
      FunctionMatchError(L, "PublicDataMember");
    return 1;
  }
  static int GetMember(lua_State *L) {
    Class1 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      int returnValue = self->GetMember();
      lua_pushinteger(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetMember");
    return 1;
  }
  static int SetMember(lua_State *L) {
    Class1 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isnumber(L, 2)) {
      int value = (int)luaL_checkinteger(L, 2);
      self->SetMember(value);
    }
    else
      FunctionMatchError(L, "SetMember");
    return 1;
  }
  static int GetString(lua_State *L) {
    Class1 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      const char * returnValue = self->GetString();
      lua_pushstring(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetString");
    return 1;
  }
  static int SetString(lua_State *L) {
    Class1 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isstring(L, 2)) {
      const char * value = (const char *)luaL_checkstring(L, 2);
      self->SetString(value);
    }
    else
      FunctionMatchError(L, "SetString");
    return 1;
  }
  static int Create(lua_State *L) {
    Class1 *self = NULL;
    int stackCount = lua_gettop(L);
    if (stackCount == 0)
      self = new Class1;
    else if ((stackCount == 1)
        && lua_isnumber(L, 1)) {
      int arg = (int)luaL_checkinteger(L, 1);
      self = new Class1(arg);
    }
    else if ((stackCount == 2)
        && lua_isnumber(L, 1)
        && lua_isstring(L, 2)) {
      int arg = (int)luaL_checkinteger(L, 1);
      const char * arg2 = (const char *)luaL_checkstring(L, 2);
      self = new Class1(arg, arg2);
    }
    else
      FunctionMatchError(L, "Class1");
    *(void **)lua_newuserdata(L, sizeof(void *)) = self;
    luaL_getmetatable(L, "Class1");
    lua_setmetatable(L, -2);
    return 1;
  }
  static Class1 *Check(lua_State *L, int narg) {
    luaL_checktype(L, narg, LUA_TUSERDATA);
    void *self = luaL_checkudata(L, narg, "Class1");
    if (!self)
      luaL_typerror(L, narg, "Class1");
    return *(Class1**)self;
  }
  static int Dispose(lua_State *L) {
    Class1 *self = (Class1*)(*(void **)(lua_touserdata(L, 1)));
    delete self;
    return 0;
  }
public:
  static int Register(lua_State *L) {
    return RegisterClass(L, "Class1", MethodTable, Dispose, Create);
  }
  static int Adopt(lua_State *L, Class1 *obj) {
    *(void **)lua_newuserdata(L, sizeof(void *)) = obj;
    luaL_getmetatable(L, "Class1");
    lua_setmetatable(L, -2);
    return 1;
  }
  static int Orphan(lua_State *L) {
    Class1 **objp = (Class1 **)luaL_checkudata(L, 1, "Class1");
    *objp = NULL;
    return 1;
  }
};
const luaL_reg Bindings_Class1::MethodTable[] = {
  {"GetMember", Bindings_Class1::GetMember},
  {"SetMember", Bindings_Class1::SetMember},
  {"GetString", Bindings_Class1::GetString},
  {"SetString", Bindings_Class1::SetString},
  {"PublicDataMember", Bindings_Class1::PublicDataMember},
  {"Orphan", Bindings_Class1::Orphan},
  {NULL, NULL}
};

class Bindings_Class2 {
  static const luaL_reg MethodTable[];
  static int PublicDataMember(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      int returnValue = self->PublicDataMember;
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->PublicDataMember = (int)luaL_checkinteger(L, 2);
    else
      FunctionMatchError(L, "PublicDataMember");
    return 1;
  }
  static int GetMember(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      int returnValue = self->GetMember();
      lua_pushinteger(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetMember");
    return 1;
  }
  static int SetMember(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isnumber(L, 2)) {
      int value = (int)luaL_checkinteger(L, 2);
      self->SetMember(value);
    }
    else
      FunctionMatchError(L, "SetMember");
    return 1;
  }
  static int GetString(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      const char * returnValue = self->GetString();
      lua_pushstring(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetString");
    return 1;
  }
  static int SetString(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isstring(L, 2)) {
      const char * value = (const char *)luaL_checkstring(L, 2);
      self->SetString(value);
    }
    else
      FunctionMatchError(L, "SetString");
    return 1;
  }
  static int GetFloat(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      float returnValue = self->GetFloat();
      lua_pushnumber(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetFloat");
    return 1;
  }
  static int SetFloat(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isnumber(L, 2)) {
      float value = (float)luaL_checknumber(L, 2);
      self->SetFloat(value);
    }
    else
      FunctionMatchError(L, "SetFloat");
    return 1;
  }
  static int OverloadedFunction(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 3)
        && lua_isnumber(L, 2)
        && lua_isstring(L, 3)) {
      int intArg = (int)luaL_checkinteger(L, 2);
      const char * strArg = (const char *)luaL_checkstring(L, 3);
      int returnValue = self->OverloadedFunction(intArg, strArg);
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 3)
        && lua_isstring(L, 2)
        && lua_isnumber(L, 3)) {
      const char * strArg = (const char *)luaL_checkstring(L, 2);
      int intArg = (int)luaL_checkinteger(L, 3);
      float returnValue = self->OverloadedFunction(strArg, intArg);
      lua_pushnumber(L, returnValue);
    }
    else
      FunctionMatchError(L, "OverloadedFunction");
    return 1;
  }
  static int PublicFunction(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      self->PublicFunction();
    }
    else
      FunctionMatchError(L, "PublicFunction");
    return 1;
  }
  static int ReturnThis(lua_State *L) {
    Class2 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      class Class2 * returnValue = self->ReturnThis();
      Bindings_Class2::Adopt(L, returnValue);
    }
    else
      FunctionMatchError(L, "ReturnThis");
    return 1;
  }
  static int Create(lua_State *L) {
    Class2 *self = NULL;
    int stackCount = lua_gettop(L);
    if (stackCount == 0)
      self = new Class2;
    else if ((stackCount == 1)
        && lua_isnumber(L, 1)) {
      float arg = (float)luaL_checknumber(L, 1);
      self = new Class2(arg);
    }
    else if ((stackCount == 1)
        && lua_isnumber(L, 1)) {
      int arg = (int)luaL_checkinteger(L, 1);
      self = new Class2(arg);
    }
    else if ((stackCount == 2)
        && lua_isnumber(L, 1)
        && lua_isstring(L, 2)) {
      int arg = (int)luaL_checkinteger(L, 1);
      const char * arg2 = (const char *)luaL_checkstring(L, 2);
      self = new Class2(arg, arg2);
    }
    else if ((stackCount == 3)
        && lua_isnumber(L, 1)
        && lua_isnumber(L, 2)
        && lua_isstring(L, 3)) {
      int arg = (int)luaL_checkinteger(L, 1);
      float farg = (float)luaL_checknumber(L, 2);
      const char * arg2 = (const char *)luaL_checkstring(L, 3);
      self = new Class2(arg, farg, arg2);
    }
    else
      FunctionMatchError(L, "Class2");
    *(void **)lua_newuserdata(L, sizeof(void *)) = self;
    luaL_getmetatable(L, "Class2");
    lua_setmetatable(L, -2);
    return 1;
  }
  static Class2 *Check(lua_State *L, int narg) {
    luaL_checktype(L, narg, LUA_TUSERDATA);
    void *self = luaL_checkudata(L, narg, "Class2");
    if (!self)
      luaL_typerror(L, narg, "Class2");
    return *(Class2**)self;
  }
  static int Dispose(lua_State *L) {
    Class2 *self = (Class2*)(*(void **)(lua_touserdata(L, 1)));
    delete self;
    return 0;
  }
public:
  static int Register(lua_State *L) {
    return RegisterClass(L, "Class2", MethodTable, Dispose, Create);
  }
  static int Adopt(lua_State *L, Class2 *obj) {
    *(void **)lua_newuserdata(L, sizeof(void *)) = obj;
    luaL_getmetatable(L, "Class2");
    lua_setmetatable(L, -2);
    return 1;
  }
  static int Orphan(lua_State *L) {
    Class2 **objp = (Class2 **)luaL_checkudata(L, 1, "Class2");
    *objp = NULL;
    return 1;
  }
};
const luaL_reg Bindings_Class2::MethodTable[] = {
  {"GetMember", Bindings_Class2::GetMember},
  {"SetMember", Bindings_Class2::SetMember},
  {"GetString", Bindings_Class2::GetString},
  {"SetString", Bindings_Class2::SetString},
  {"GetFloat", Bindings_Class2::GetFloat},
  {"SetFloat", Bindings_Class2::SetFloat},
  {"OverloadedFunction", Bindings_Class2::OverloadedFunction},
  {"PublicFunction", Bindings_Class2::PublicFunction},
  {"ReturnThis", Bindings_Class2::ReturnThis},
  {"PublicDataMember", Bindings_Class2::PublicDataMember},
  {"Orphan", Bindings_Class2::Orphan},
  {NULL, NULL}
};

class Bindings_Class3 {
  static const luaL_reg MethodTable[];
  static int PublicDataMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      int returnValue = self->PublicDataMember;
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->PublicDataMember = (int)luaL_checkinteger(L, 2);
    else
      FunctionMatchError(L, "PublicDataMember");
    return 1;
  }
  static int IntMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      int returnValue = self->IntMember;
      lua_pushinteger(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->IntMember = (int)luaL_checkinteger(L, 2);
    else
      FunctionMatchError(L, "IntMember");
    return 1;
  }
  static int FloatMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      float returnValue = self->FloatMember;
      lua_pushnumber(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->FloatMember = (float)luaL_checknumber(L, 2);
    else
      FunctionMatchError(L, "FloatMember");
    return 1;
  }
  static int DoubleMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      double returnValue = self->DoubleMember;
      lua_pushnumber(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isnumber(L, 2)) // setter
      self->DoubleMember = (double)luaL_checknumber(L, 2);
    else
      FunctionMatchError(L, "DoubleMember");
    return 1;
  }
  static int StringMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      const char * returnValue = self->StringMember;
      lua_pushstring(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isstring(L, 2)) // setter
      self->StringMember = (const char *)luaL_checkstring(L, 2);
    else
      FunctionMatchError(L, "StringMember");
    return 1;
  }
  static int StructMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      MyFunctions::StructType *returnValue = new MyFunctions::StructType(self->StructMember);
      Bindings_StructType::Adopt(L, returnValue);
    }
    else if ((stackCount == 2) && luaL_checkudata(L, 2, "StructType")) // setter
      self->StructMember = **(MyFunctions::StructType **)luaL_checkudata(L, 2, "StructType");
    else
      FunctionMatchError(L, "StructMember");
    return 1;
  }
  static int StructPointerMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      MyFunctions::StructType *returnValue = self->StructPointerMember;
      Bindings_StructType::Adopt(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isuserdata(L, 2)) // setter
      self->StructPointerMember = *(MyFunctions::StructType**)luaL_checkudata(L, 2, "StructType");
    else
      FunctionMatchError(L, "StructPointerMember");
    return 1;
  }
  static int ClassMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      MyFunctions::ClassType *returnValue = new MyFunctions::ClassType(self->ClassMember);
      Bindings_ClassType::Adopt(L, returnValue);
    }
    else if ((stackCount == 2) && luaL_checkudata(L, 2, "ClassType")) // setter
      self->ClassMember = **(MyFunctions::ClassType **)luaL_checkudata(L, 2, "ClassType");
    else
      FunctionMatchError(L, "ClassMember");
    return 1;
  }
  static int ClassPointerMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) { // getter
      MyFunctions::ClassType *returnValue = self->ClassPointerMember;
      Bindings_ClassType::Adopt(L, returnValue);
    }
    else if ((stackCount == 2) && lua_isuserdata(L, 2)) // setter
      self->ClassPointerMember = *(MyFunctions::ClassType**)luaL_checkudata(L, 2, "ClassType");
    else
      FunctionMatchError(L, "ClassPointerMember");
    return 1;
  }
  static int GetMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      int returnValue = self->GetMember();
      lua_pushinteger(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetMember");
    return 1;
  }
  static int SetMember(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isnumber(L, 2)) {
      int value = (int)luaL_checkinteger(L, 2);
      self->SetMember(value);
    }
    else
      FunctionMatchError(L, "SetMember");
    return 1;
  }
  static int GetString(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if (stackCount == 1) {
      const char * returnValue = self->GetString();
      lua_pushstring(L, returnValue);
    }
    else
      FunctionMatchError(L, "GetString");
    return 1;
  }
  static int SetString(lua_State *L) {
    Class3 *self = Check(L, 1);
    int stackCount = lua_gettop(L);
    if ((stackCount == 2)
        && lua_isstring(L, 2)) {
      const char * value = (const char *)luaL_checkstring(L, 2);
      self->SetString(value);
    }
    else
      FunctionMatchError(L, "SetString");
    return 1;
  }
  static int Create(lua_State *L) {
    Class3 *self = NULL;
    int stackCount = lua_gettop(L);
    if (stackCount == 0)
      self = new Class3;
    else
      FunctionMatchError(L, "Class3");
    *(void **)lua_newuserdata(L, sizeof(void *)) = self;
    luaL_getmetatable(L, "Class3");
    lua_setmetatable(L, -2);
    return 1;
  }
  static Class3 *Check(lua_State *L, int narg) {
    luaL_checktype(L, narg, LUA_TUSERDATA);
    void *self = luaL_checkudata(L, narg, "Class3");
    if (!self)
      luaL_typerror(L, narg, "Class3");
    return *(Class3**)self;
  }
  static int Dispose(lua_State *L) {
    Class3 *self = (Class3*)(*(void **)(lua_touserdata(L, 1)));
    delete self;
    return 0;
  }
public:
  static int Register(lua_State *L) {
    return RegisterClass(L, "Class3", MethodTable, Dispose, Create);
  }
  static int Adopt(lua_State *L, Class3 *obj) {
    *(void **)lua_newuserdata(L, sizeof(void *)) = obj;
    luaL_getmetatable(L, "Class3");
    lua_setmetatable(L, -2);
    return 1;
  }
  static int Orphan(lua_State *L) {
    Class3 **objp = (Class3 **)luaL_checkudata(L, 1, "Class3");
    *objp = NULL;
    return 1;
  }
};
const luaL_reg Bindings_Class3::MethodTable[] = {
  {"GetMember", Bindings_Class3::GetMember},
  {"SetMember", Bindings_Class3::SetMember},
  {"GetString", Bindings_Class3::GetString},
  {"SetString", Bindings_Class3::SetString},
  {"PublicDataMember", Bindings_Class3::PublicDataMember},
  {"IntMember", Bindings_Class3::IntMember},
  {"FloatMember", Bindings_Class3::FloatMember},
  {"DoubleMember", Bindings_Class3::DoubleMember},
  {"StringMember", Bindings_Class3::StringMember},
  {"StructMember", Bindings_Class3::StructMember},
  {"StructPointerMember", Bindings_Class3::StructPointerMember},
  {"ClassMember", Bindings_Class3::ClassMember},
  {"ClassPointerMember", Bindings_Class3::ClassPointerMember},
  {"Orphan", Bindings_Class3::Orphan},
  {NULL, NULL}
};

int Bindings_GlobalIntVariable(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) { // getter
    int returnValue = GlobalIntVariable;
    lua_pushinteger(L, returnValue);
  }
  else if ((stackCount == 1) && lua_isnumber(L, 1)) // setter
    GlobalIntVariable = (int)luaL_checkinteger(L, 1);
  else
    FunctionMatchError(L, "GlobalIntVariable");
  return 1;
}

int Bindings_NamespaceIntVariable(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) { // getter
    int returnValue = VariableNamespace::NamespaceIntVariable;
    lua_pushinteger(L, returnValue);
  }
  else if ((stackCount == 1) && lua_isnumber(L, 1)) // setter
    VariableNamespace::NamespaceIntVariable = (int)luaL_checkinteger(L, 1);
  else
    FunctionMatchError(L, "NamespaceIntVariable");
  return 1;
}

int Bindings_VoidFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    VoidFunction();
  }
  else
    FunctionMatchError(L, "VoidFunction");
  return 1;
}

int Bindings_IntFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    int returnValue = MyFunctions::IntFunction();
    lua_pushinteger(L, returnValue);
  }
  else
    FunctionMatchError(L, "IntFunction");
  return 1;
}

int Bindings_LongFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    long returnValue = MyFunctions::LongFunction();
    lua_pushinteger(L, returnValue);
  }
  else
    FunctionMatchError(L, "LongFunction");
  return 1;
}

int Bindings_ShortFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    short returnValue = MyFunctions::ShortFunction();
    lua_pushinteger(L, returnValue);
  }
  else
    FunctionMatchError(L, "ShortFunction");
  return 1;
}

int Bindings_UnsignedFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    unsigned int returnValue = MyFunctions::UnsignedFunction();
    lua_pushinteger(L, returnValue);
  }
  else
    FunctionMatchError(L, "UnsignedFunction");
  return 1;
}

int Bindings_FloatFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    float returnValue = MyFunctions::FloatFunction();
    lua_pushnumber(L, returnValue);
  }
  else
    FunctionMatchError(L, "FloatFunction");
  return 1;
}

int Bindings_DoubleFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    double returnValue = MyFunctions::DoubleFunction();
    lua_pushnumber(L, returnValue);
  }
  else
    FunctionMatchError(L, "DoubleFunction");
  return 1;
}

int Bindings_VoidPointerFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    void * returnValue = MyFunctions::VoidPointerFunction();
    lua_pushinteger(L, (size_t)returnValue);
  }
  else
    FunctionMatchError(L, "VoidPointerFunction");
  return 1;
}

int Bindings_IntPointerFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    int * returnValue = MyFunctions::IntPointerFunction();
    lua_pushinteger(L, (size_t)returnValue);
  }
  else
    FunctionMatchError(L, "IntPointerFunction");
  return 1;
}

int Bindings_CharFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    char returnValue = MyFunctions::CharFunction();
    lua_pushinteger(L, returnValue);
  }
  else
    FunctionMatchError(L, "CharFunction");
  return 1;
}

int Bindings_CharPointerFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    char * returnValue = MyFunctions::CharPointerFunction();
    lua_pushstring(L, returnValue);
  }
  else
    FunctionMatchError(L, "CharPointerFunction");
  return 1;
}

int Bindings_ConstCharPointerFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    const char * returnValue = MyFunctions::ConstCharPointerFunction();
    lua_pushstring(L, returnValue);
  }
  else
    FunctionMatchError(L, "ConstCharPointerFunction");
  return 1;
}

int Bindings_StructFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    struct MyFunctions::StructType *returnValue = new MyFunctions::StructType(MyFunctions::StructFunction());
    Bindings_StructType::Adopt(L, returnValue);
  }
  else
    FunctionMatchError(L, "StructFunction");
  return 1;
}

int Bindings_StructPointerFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    struct MyFunctions::StructType * returnValue = MyFunctions::StructPointerFunction();
    Bindings_StructType::Adopt(L, returnValue);
  }
  else
    FunctionMatchError(L, "StructPointerFunction");
  return 1;
}

int Bindings_ClassFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    class MyFunctions::ClassType *returnValue = new MyFunctions::ClassType(MyFunctions::ClassFunction());
    Bindings_ClassType::Adopt(L, returnValue);
  }
  else
    FunctionMatchError(L, "ClassFunction");
  return 1;
}

int Bindings_ClassPointerFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    class MyFunctions::ClassType * returnValue = MyFunctions::ClassPointerFunction();
    Bindings_ClassType::Adopt(L, returnValue);
  }
  else
    FunctionMatchError(L, "ClassPointerFunction");
  return 1;
}

int Bindings_EnumFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if (stackCount == 0) {
    enum MyFunctions::EnumType returnValue = MyFunctions::EnumFunction();
    lua_pushinteger(L, (lua_Integer)returnValue);
  }
  else
    FunctionMatchError(L, "EnumFunction");
  return 1;
}

int Bindings_FunctionIntArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isnumber(L, 1)) {
    int intArg1 = (int)luaL_checkinteger(L, 1);
    MyFunctions::FunctionIntArg(intArg1);
  }
  else
    FunctionMatchError(L, "FunctionIntArg");
  return 1;
}

int Bindings_FunctionFloatArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isnumber(L, 1)) {
    float floatArg1 = (float)luaL_checknumber(L, 1);
    MyFunctions::FunctionFloatArg(floatArg1);
  }
  else
    FunctionMatchError(L, "FunctionFloatArg");
  return 1;
}

int Bindings_FunctionDoubleArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isnumber(L, 1)) {
    double doubleArg1 = (double)luaL_checknumber(L, 1);
    MyFunctions::FunctionDoubleArg(doubleArg1);
  }
  else
    FunctionMatchError(L, "FunctionDoubleArg");
  return 1;
}

int Bindings_FunctionIntPointerArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isnumber(L, 1)) {
    int * intPointerArg1 = (int *)luaL_checkinteger(L, 1);
    MyFunctions::FunctionIntPointerArg(intPointerArg1);
  }
  else
    FunctionMatchError(L, "FunctionIntPointerArg");
  return 1;
}

int Bindings_FunctionCharArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isnumber(L, 1)) {
    char charArg1 = (char)luaL_checkinteger(L, 1);
    MyFunctions::FunctionCharArg(charArg1);
  }
  else
    FunctionMatchError(L, "FunctionCharArg");
  return 1;
}

int Bindings_FunctionCharPointerArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isstring(L, 1)) {
    char * charPointerArg1 = (char *)luaL_checkstring(L, 1);
    MyFunctions::FunctionCharPointerArg(charPointerArg1);
  }
  else
    FunctionMatchError(L, "FunctionCharPointerArg");
  return 1;
}

int Bindings_FunctionConstCharPointerArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isstring(L, 1)) {
    const char * constCharPointerArg1 = (const char *)luaL_checkstring(L, 1);
    MyFunctions::FunctionConstCharPointerArg(constCharPointerArg1);
  }
  else
    FunctionMatchError(L, "FunctionConstCharPointerArg");
  return 1;
}

int Bindings_FunctionStructArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && luaL_checkudata(L, 1, "StructType")) {
    struct MyFunctions::StructType * structArg1 = *(MyFunctions::StructType **)luaL_checkudata(L, 1, "StructType");
    MyFunctions::FunctionStructArg(*structArg1);
  }
  else
    FunctionMatchError(L, "FunctionStructArg");
  return 1;
}

int Bindings_FunctionStructPointerArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isuserdata(L, 1)) {
    struct MyFunctions::StructType * structPointerArg1 = *(MyFunctions::StructType**)luaL_checkudata(L, 1, "StructType");
    MyFunctions::FunctionStructPointerArg(structPointerArg1);
  }
  else
    FunctionMatchError(L, "FunctionStructPointerArg");
  return 1;
}

int Bindings_FunctionClassArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && luaL_checkudata(L, 1, "ClassType")) {
    class MyFunctions::ClassType * classArg1 = *(MyFunctions::ClassType **)luaL_checkudata(L, 1, "ClassType");
    MyFunctions::FunctionClassArg(*classArg1);
  }
  else
    FunctionMatchError(L, "FunctionClassArg");
  return 1;
}

int Bindings_FunctionClassPointerArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isuserdata(L, 1)) {
    class MyFunctions::ClassType * classPointerArg1 = *(MyFunctions::ClassType**)luaL_checkudata(L, 1, "ClassType");
    MyFunctions::FunctionClassPointerArg(classPointerArg1);
  }
  else
    FunctionMatchError(L, "FunctionClassPointerArg");
  return 1;
}

int Bindings_FunctionEnumArg(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isnumber(L, 1)) {
    enum MyFunctions::EnumType enumArg1 = (enum MyFunctions::EnumType)luaL_checkinteger(L, 1);
    MyFunctions::FunctionEnumArg(enumArg1);
  }
  else
    FunctionMatchError(L, "FunctionEnumArg");
  return 1;
}

int Bindings_FunctionIntArgs(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 2)
      && lua_isnumber(L, 1)
      && lua_isnumber(L, 2)) {
    int intArg1 = (int)luaL_checkinteger(L, 1);
    int intArg2 = (int)luaL_checkinteger(L, 2);
    OtherFunctions::FunctionIntArgs(intArg1, intArg2);
  }
  else
    FunctionMatchError(L, "FunctionIntArgs");
  return 1;
}

int Bindings_BoundFunction(lua_State *L) {
  int stackCount = lua_gettop(L);
  if ((stackCount == 1)
      && lua_isstring(L, 1)) {
    const char * argString = (const char *)luaL_checkstring(L, 1);
    int returnValue = BoundFunction(argString);
    lua_pushinteger(L, returnValue);
  }
  else
    FunctionMatchError(L, "BoundFunction");
  return 1;
}

const luaL_reg FunctionTable[] = {
  {"VoidFunction", Bindings_VoidFunction},
  {"IntFunction", Bindings_IntFunction},
  {"LongFunction", Bindings_LongFunction},
  {"ShortFunction", Bindings_ShortFunction},
  {"UnsignedFunction", Bindings_UnsignedFunction},
  {"FloatFunction", Bindings_FloatFunction},
  {"DoubleFunction", Bindings_DoubleFunction},
  {"VoidPointerFunction", Bindings_VoidPointerFunction},
  {"IntPointerFunction", Bindings_IntPointerFunction},
  {"CharFunction", Bindings_CharFunction},
  {"CharPointerFunction", Bindings_CharPointerFunction},
  {"ConstCharPointerFunction", Bindings_ConstCharPointerFunction},
  {"StructFunction", Bindings_StructFunction},
  {"StructPointerFunction", Bindings_StructPointerFunction},
  {"ClassFunction", Bindings_ClassFunction},
  {"ClassPointerFunction", Bindings_ClassPointerFunction},
  {"EnumFunction", Bindings_EnumFunction},
  {"FunctionIntArg", Bindings_FunctionIntArg},
  {"FunctionFloatArg", Bindings_FunctionFloatArg},
  {"FunctionDoubleArg", Bindings_FunctionDoubleArg},
  {"FunctionIntPointerArg", Bindings_FunctionIntPointerArg},
  {"FunctionCharArg", Bindings_FunctionCharArg},
  {"FunctionCharPointerArg", Bindings_FunctionCharPointerArg},
  {"FunctionConstCharPointerArg", Bindings_FunctionConstCharPointerArg},
  {"FunctionStructArg", Bindings_FunctionStructArg},
  {"FunctionStructPointerArg", Bindings_FunctionStructPointerArg},
  {"FunctionClassArg", Bindings_FunctionClassArg},
  {"FunctionClassPointerArg", Bindings_FunctionClassPointerArg},
  {"FunctionEnumArg", Bindings_FunctionEnumArg},
  {"FunctionIntArgs", Bindings_FunctionIntArgs},
  {"BoundFunction", Bindings_BoundFunction},
  {"GlobalIntVariable", Bindings_GlobalIntVariable},
  {"NamespaceIntVariable", Bindings_NamespaceIntVariable},
  {NULL, NULL}
};

void Open(lua_State *L) {
  Bindings_EnumType(L);
  Bindings_StructType::Register(L);
  Bindings_ClassType::Register(L);
  Bindings_Class1::Register(L);
  Bindings_Class2::Register(L);
  Bindings_Class3::Register(L);
  luaL_register(L, "Bindings", FunctionTable);
}

} // namespace Bindings
