// Function.cpp - Example file for Clang LuaBinding plugin.  This file contains the definitions of the
//     of the binding targets.

#include <stdio.h>
#include "../BindIn/Class.h"

Class1::Class1() {
  member = -1;
  str = NULL;
}

Class1::Class1(int arg) {
  member = arg;
  str = NULL;
}

Class1::Class1(int arg, const char *arg2) {
  member = arg;
  str = arg2;
}

Class1::~Class1() {
}

int Class1::GetMember() {
  return member;
}

void Class1::SetMember(int value) {
  member = value;
}

const char *Class1::GetString() {
  return str;
}

void Class1::SetString(const char *value) {
  str = value;
}

Class2::Class2() {
  flt = 1.0;
}

Class2::Class2(float arg) {
  flt = arg;
}

Class2::Class2(int arg) : Class1(arg) {
  flt = 1.0;
}

Class2::Class2(int arg, const char *arg2) : Class1(arg, arg2) {
  flt = 1.0;
}

Class2::Class2(int arg, float farg, const char *arg2) : Class1(arg, arg2) {
  flt = farg;
}

Class2::~Class2() {
}

float Class2::GetFloat() {
  return flt;
}

void Class2::SetFloat(float value) {
  flt = value;
}

int Class2::OverloadedFunction(int intArg, const char *strArg) {
  printf("Overload 1 called: %s\n", strArg);
  member = intArg;
  str = strArg;
  return member;
}

float Class2::OverloadedFunction(const char *strArg, int intArg)
{
  printf("Overload 2 called: %s\n", strArg);
  member = intArg;
  str = strArg;
  return flt;
}

Class3::Class3() :
  ClassMember(987)
{
  IntMember = 123;
  FloatMember = 1.234f;
  DoubleMember = 2.345;
  StringMember = "StringMember";
  StructMember.member = 654;
  StructPointerMember = new MyFunctions::StructType;
  ClassPointerMember = new MyFunctions::ClassType(876);
}

int GlobalIntVariable = 345;

namespace VariableNamespace {
  int NamespaceIntVariable = 456;
}

int BoundFunction(const char *argString)
{
	printf("I have been called!  argString: %s  Returning 1234\n", argString);
	return 1234;
}
